local Lib = MissionMinder;
local PreLoadLib = MissionMinderPreLoad;
Lib.callbacks = Lib.callbacks or LibStub("CallbackHandler-1.0"):New(Lib)

local options = Lib.options;
local DEBUG = Lib.debug;

Lib.tracker = {};
local module = Lib.tracker;
local selectedPlayer = nil

local L = LibStub("AceLocale-3.0"):GetLocale("MissionMinder");


local function getPlayerName()
	return GetUnitName("player") .. "-" .. GetRealmName()
end

local function selectCharacter(self)
	selectedPlayer = self.value
	GarrisonLandingPageReport.CharacterName:SetText(self.value)
	MissionMinderChangeMenu_Toggle()
end

local function selectCurrentPlayer()
	selectedPlayer = getPlayerName()
	GarrisonLandingPageReport.CharacterName:SetText(player)
end

function MissionMinderGarrisonResourceCache_OnEnter(self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR_RIGHT")
		GameTooltip:SetText(GARRISON_CACHE)
		GameTooltip:Show()
end

local function trackMission(event, missionID, ...)
	local player = getPlayerName()
	local now = GetTime()

	local missions = PreLoadLib.Globals.Characters[player].missions
	if ( not missions ) then
		missions = {}
		PreLoadLib.Globals.Characters[player].missions = missions
	end

	local _, totalTimeInSeconds = C_Garrison.GetPartyMissionInfo(missionID);
	if (totalTimeInSeconds) then
		missions[missionID] = now + totalTimeInSeconds
	end
end

local function untrackMission(event, missionID)
	local player = getPlayerName()

	local missions = PreLoadLib.Globals.Characters[player].missions
	if ( missions ) then
		missions[missionID] = nil
	end
end


function MissionMinderChangeMenu_Toggle()
	ToggleDropDownMenu(1, nil, GarrisonLandingPageReport.CharacterMenu, GarrisonLandingPageReport.ChangeCharacter, 0, 0);
end

function MissionMinderCharacterMenuDropDown_Initialize()
	local currentPlayer = getPlayerName()
	info = {}

	--info.text = CHARACTERS
	--info.isTitle = true
	--UIDropDownMenu_AddButton(info);

	info.isTitle = false
	info.text = currentPlayer
	info.value = currentPlayer
	info.func = selectPlayer
	UIDropDownMenu_AddButton(info)

	for character, _ in pairs(PreLoadLib.Globals.Characters) then
		if ( character ~= currentPlayer) then
			info.text = character
			info.value = character
			UIDropDownMenu_AddButton(info)
		end
	end
end

local function initialize()
	DEBUG("   |cffffffffTracker|r initialized");

	-- Create CharacterName fontstring
	GarrisonLandingPageReport.CharacterName = GarrisonLandingPageReport:CreateFontString(nil, "BORDER", "GameFontNormal")
	GarrisonLandingPageReport.CharacterName:SetPoint("TOPLEFT", GarrisonLandingPage.HeaderBar, "BOTTOMLEFT", 26, 13)
	GarrisonLandingPageReport.CharacterName:Show()

	-- Set the default player to the current player
	selectCurrentPlayer()

	-- Reset seleccted player on LandingPage close
	GarrisonLandingPage:HookScript("OnHide", selectCurrentPlayer)

	-- Track mission progress across multiple characters
	Lib.RegisterCallback("tracker", "MISSION_STARTED", trackMission)
	Lib.RegisterCallback("tracker", "MISSION_COMPLETED", untrackMission)
end

local events = Lib.events
events:RegisterEvent("tracker", "ADDON_LOADED", initialize);
